
import FreyjaModeler
from FreyjaModeler import *

import string
import math
import types
import re
import gtk
import pygtk
from math import *


def UnitTest(args):
	mesh = freyjaMeshCreate()
	v = []
	v.append(freyjaMeshVertexCreate3fv(mesh, 0, 0, 0))
	v.append(freyjaMeshVertexCreate3fv(mesh, 10, 0, 0))
	v.append(freyjaMeshVertexCreate3fv(mesh, 10, 10, 0))
	v.append(freyjaMeshVertexCreate3fv(mesh, 0, 10, 10))

	face = freyjaMeshPolygonCreate(mesh)

	for i in v:
		freyjaMeshPolygonAddVertex1i(mesh, face, v[i])

	return True

def ConstructVault(length, breadth, pointy):
	mesh = freyjaMeshCreate()

	i=0.0
	j=0.0

	n=32 #.0
	l=length
	b=breadth
	p=pointy
	d=sqrt(l*l+b*b)
	alpha=acos(1-1/(2*p))
	theta=alpha/n
	rl=l*p*2.0
	rb=b*p*2.0
	rd=d*p*2.0

	verts = []
	x = y = z = 0.0

	for i in range(0,n+1):
		for j in range(0,n+1):
			x=(cos(alpha)-cos(theta*i))*rb
			y=(cos(alpha)-cos(theta*j))*rl
			if i<j:
				z=sin(theta*i)*(rd-rl)+sin(theta*j)*rl
			else:
				z=sin(theta*j)*(rd-rb)+sin(theta*i)*rb
			v=freyjaMeshVertexCreate3fv(mesh,x,z,y)
			verts.append(v)


	n0=len(range(0,n+1))

	for i in range(0,n):  
		for j in range(0,n):  
			if i==j:
				face=freyjaMeshPolygonCreate(mesh) 
				freyjaMeshPolygonAddVertex1i(mesh, face, verts[i*n0+j])  
				freyjaMeshPolygonAddVertex1i(mesh, face, verts[i*n0+j+1])
				freyjaMeshPolygonAddVertex1i(mesh, face, verts[(i+1)*n0+j+1])  
				

				face=freyjaMeshPolygonCreate(mesh)
				freyjaMeshPolygonAddVertex1i(mesh, face, verts[i*n0+j])  
				freyjaMeshPolygonAddVertex1i(mesh, face, verts[(i+1)*n0+j+1])  
				freyjaMeshPolygonAddVertex1i(mesh, face, verts[(i+1)*n0+j]) 
				

			else:
				face=freyjaMeshPolygonCreate(mesh)
				freyjaMeshPolygonAddVertex1i(mesh, face, verts[i*n0+j])  
				freyjaMeshPolygonAddVertex1i(mesh, face, verts[i*n0+j+1])  
				freyjaMeshPolygonAddVertex1i(mesh, face, verts[(i+1)*n0+j+1])  
				freyjaMeshPolygonAddVertex1i(mesh, face, verts[(i+1)*n0+j]) 
				


def hello(widget, data=None):
	ConstructVault(50,50,2)

def windowtest():
	window = gtk.Window(gtk.WINDOW_TOPLEVEL)
	#window.connect("delete_event", delete_event)
	#window.connect("destroy", destroy)
	window.set_border_width(10)
	button = gtk.Button("Hello World")
	button.connect("clicked", hello, None)
	button.connect_object("clicked", gtk.Widget.destroy, window)
	window.add(button)
	button.show()
	window.show()
	gtk.main()



def PluginEntry(symbol, args):

	print symbol + " " + args

	if re.match('.*ImportModel', symbol):
		ConstructVault(50.0,50.0,0.5)



PluginEntry(FreyjaSymbol, FreyjaArgs)


